create table Studente(
	matricola integer not null primary key,
	provincia varchar(64),
	regione varchar(64),
	maturita varchar(64),
	votoMaturita integer,
	nome varchar(64),
	cognome varchar(64)
);

create table Facolta(
	codice varchar(32) not null primary key,
	nome varchar(32)
);

create table CorsoDiStudi(
	codice varchar(32) not null primary key,
	nome varchar(64),
	tipo varchar(32),
	facolta varchar(32)
);

alter table CorsoDiStudi
	add foreign key (facolta)
	references facolta(codice);


create table Docente (
	codice varchar(32) not null primary key,
	nome varchar(32),
	qualifica varchar(32),
	facolta varchar(32)
);

alter table Docente
	add foreign key (facolta)
	references facolta(codice);

create table Corso (
	codice varchar(32) not null primary key,
	crediti integer,
	cds varchar(32),
	facolta varchar(32),
	nome varchar(32)
);

alter table Corso
	add foreign key (facolta)
	references facolta(codice);

alter table Corso
	add foreign key (cds)
	references CorsoDiStudi(codice);

create table AnnoAccademico(
	codice varchar(32) not null primary key,
	nome varchar(32),
	anno varchar(32)
);

create table EdizioneCorso(
	corso varchar(32) not null,
	aa  varchar(32) not null,
	primary key(corso,aa)
);

alter table EdizioneCorso
	add foreign key (corso)
	references corso(codice);

alter table EdizioneCorso
	add foreign key(aa)
	references AnnoAccademico(codice);
 
create table Docenza(
	corso varchar(32) not null,
	aa varchar(32) not null,
	docente varchar(32) not null,
	oreDidattica integer,
	primary key(corso, aa, docente)
);

alter table Docenza
	add foreign key (corso)
	references corso(codice);

alter table Docenza
	add foreign key(aa)
	references AnnoAccademico(codice);

alter table Docenza
	add foreign key (docente)
	references docente(codice);

create table Esame(
	studente integer not null,
	aa varchar(32) not null,
	voto integer not null,
	corso varchar(32) not null,
	primary key(studente, corso));

alter table Esame
	add foreign key(corso)
	references Corso(codice);

alter table Esame
	add foreign key (studente)
	references studente(matricola);

create table StudenteAA(
	studente integer not null,
	aa varchar(32) not null,
	votoLaurea integer,
	dataLaurea varchar(32),
	annoDiCorso varchar(32),
	cds varchar(32),
	primary key (studente, aa));

alter table StudenteAA
	add foreign key(aa)
	references AnnoAccademico(codice);


alter table StudenteAA
	add foreign key (studente)
	references studente(matricola);

